import java.util.*;


public class HoldEmDealer extends Dealer {
	
        int commCardsDealt;
    
	public HoldEmDealer(String name) {
		super(name);
                commCardsDealt = 0;
	}
	
	public void startHand(double ante, double smallBlind, double bigBlind) {
            commCardsDealt = 0;
            TableGui gui = TableGui.getTableGui();
            prepareDeck();
            setPlayerHandMucks(false);
            gui.muckAllCards();
            getTable().setCurrentBet(bigBlind);
            if(ante > 0)
		getAntes(ante);
            if(bigBlind > 0)
		getBlinds(smallBlind, bigBlind);
            gui.updatePlayerChips();
            dealToHands(2);  //HoldEm deals 2 cards to each hand
            //getTable().printPlayerHands();
            gui.startPreflop();
	}
	
	private void dealCommunityCard() {
		CardDeck deck = getCardDeck();
		Table table = getTable();
		if(deck.getNumCards() <= 0) {  //sanity check that it is ok to deal a card
			System.out.println("Cannot deal another card, the deck is empty!");
			return;
		}
		int numPlayerHands = table.getNumPlayerHands();
		Card topCard = deck.getTopCard();
		
                if(topCard != null) {  //if there are still cards in the deck
                    TableGui gui = TableGui.getTableGui();
                    gui.addCommCard(topCard.getValue() + topCard.getSuit()); 
                    for(int i = 0; i < numPlayerHands; i++) {
                        table.addCardToHand(topCard, i);
                    }
                    commCardsDealt++;
		} else {
                    System.out.println("Ran out of cards in deck - this should not have happened! =( =( =(");
                    return;
                }
	}
        
        public void update(Observable o, Object arg) {
            if(o instanceof TablePot) {
                TableGui gui = TableGui.getTableGui();
                TablePot tP = (TablePot) o;
                int activePlayers = getTable().getNumActivePlayerHands();
                boolean matched = tP.contributionsMatched(activePlayers);
                if(matched) {
                    gui.updatePotDisplay(tP.getTotal());
                    tP.setContributionsComplete();
                    if(tP.getPlayerAllIn()) {  //if a player is all in
                        getTable().createSidePot(tP);  //create a side pot for any overbets
                        //TODO: create side pot display in gui
                    }
                    //deal next round
                    if(commCardsDealt == 0) {
                        getTable().setCurrentBet(0);
                        gui.startNextBetting();
                        dealCommunityCard();
                        dealCommunityCard();
                        dealCommunityCard();
                    } else if(commCardsDealt == 3 || commCardsDealt == 4) {
                        getTable().setCurrentBet(0);
                        gui.startNextBetting();
                        dealCommunityCard();
                    } else {  //must be at end of round
                        endHand();
                    }
                } else {
                    gui.updatePotDisplay(tP.getTotal());
                    gui.incrementPlayersTurn();  //keep going around table until betting round is complete (matched)
                }            
            }
        }
	
}
